declare namespace My {
    interface TempFile {
        /**
         * @description 本地临时文件路径（本地路径）
         */
        path: string;
        /**
         * @description 本地临时文件大小，单位为 B
         */
        size: number;
    }
    interface ChooseImage {
        apFilePaths?: string[];
        tempFilePaths?: string[];
        filePaths?: string[];
        tempFiles?: TempFile[];
    }
    interface ChooseVideo {
        tempFilePath: string;
        duration: number;
        size: number;
        height: number;
        width: number;
        success: boolean;
    }
    interface ChooseFileFromDisk {
        apFilePath: string;
        success: boolean;
    }
    interface UploadFile {
        data: string;
        statusCode: string | number;
        header: string;
    }
    interface GetFileInfo {
        digest: string;
        size: number;
    }
    interface DownloadFile {
        apFilePath: string;
    }
}
export declare const chooseImage: (option: any) => Promise<My.ChooseImage>;
export declare const chooseVideo: (option: any) => Promise<My.ChooseVideo>;
export declare const chooseFileFromDisk: (option?: any) => Promise<My.ChooseFileFromDisk>;
export declare const uploadFile: (option: any) => Promise<My.UploadFile>;
export declare const getFileInfo: (option: any) => Promise<My.GetFileInfo>;
export declare const previewImage: (option: any) => void;
export declare const downloadFile: (option: any) => Promise<My.DownloadFile>;
export {};
