# builder-debug-utils

```ts
const debugUtils = require('@alipay/builder-debug-utils');

const debugUtils.generateInjectCodePath({
  target: 'Mini',
  mode: 'Preview',
  compilePlugin: false,
}); // /Users/foo/bar

tiny-cli --injectCodePath /Users/foo/bar
```

/offline/assets_map - 用于存储构建脚本文本
$TMPDIR/builder_debug_output_v2 - 用于作为 tiny-cli injectCodePath 入参

### API

- 检查更新
  比较本地与服务端资源 sha256 是否相同，若不同更新本地资源

```ts
const injectCodePath = await updateInjectCodeAssets();
```

- 生成 injectCode

```ts
await generateInjectCode({
  mode: 'Remotex',
});

generateInjectCodeSync({
  mode: 'Remotex',
});
```

- 生成 injectCodePath

```ts
await generateInjectCodePath({
  mode: 'Remotex',
});

generateInjectCodePathSync({
  mode: 'Remotex',
});
```

- 获取 boatman 资源路径

```ts
await getBoatmanBundlePath();

getBoatmanBundlePathSync();
```

## 开发

本地开发可以使用 watch 模式，watch 模式可以通过环境变量来监听指定文件的变化，可以通过 .env 文件来设置哪些文件要监听：

```sh
touch .env
```

```env
BOATMAN_PATH="path/to/boatman"
```

```sh
yarn generate:watch
```
